

#include <stdarg.h>

void pr(char *fmt, ... ){
        char buf[128]; // resulting string limited to 128 chars
        va_list args;
        va_start (args, fmt );
        vsnprintf(buf, 128, fmt, args);
        va_end (args);
        Serial.println(buf);

}



#include <digitalWriteFast.h>

#include <SerialCommand.h>


extern void __builtin_avr_delay_cycles(unsigned long __n);


// using digital pin 3 to drive transmitter

#define OUT_PIN 3

// using Analogue input 1 for receiver input

#define ANINPUT 1




#define BUFFER_SIZE 512


unsigned char buffer[BUFFER_SIZE];
unsigned char buffer2[BUFFER_SIZE];
volatile unsigned char * bufferp=buffer;
unsigned char * bufferlt=buffer+(BUFFER_SIZE-2);
unsigned char * bufferlt2=buffer2+(BUFFER_SIZE-2);

 


#define USPERIOD1 193
#define USPERIOD  193


// pulse with no phase change

void goping2(void)
{

 noInterrupts();
 digitalWriteFast2(OUT_PIN, 1); //0
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);

 
 digitalWriteFast2(OUT_PIN, 1); //1
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);

 digitalWriteFast2(OUT_PIN, 1); //2
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //3
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //4
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //5
 __builtin_avr_delay_cycles(USPERIOD1);


 
 digitalWriteFast2(OUT_PIN, 0); //6
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0); //7
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0); //8
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);


 digitalWriteFast2(OUT_PIN, 0); //9
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);


 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0);


 interrupts();
}


// pulse with phase change

void goping(void)
{

 noInterrupts();
 digitalWriteFast2(OUT_PIN, 1); //0
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);

 
 digitalWriteFast2(OUT_PIN, 1); //1
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);

 digitalWriteFast2(OUT_PIN, 1); //2
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //3
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //4
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //5
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD1);


 
 digitalWriteFast2(OUT_PIN, 0); //6
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0); //7
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0); //8
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);


 digitalWriteFast2(OUT_PIN, 0); //9
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);


 digitalWriteFast2(OUT_PIN, 0);

 interrupts();
}


void shortpause(void)
{
 __builtin_avr_delay_cycles(USPERIOD*100);
 __builtin_avr_delay_cycles(USPERIOD*100);
 __builtin_avr_delay_cycles(USPERIOD*100);
 __builtin_avr_delay_cycles(USPERIOD*100);
 __builtin_avr_delay_cycles(USPERIOD*100);
 __builtin_avr_delay_cycles(USPERIOD*100);
}




void dumpdata(void)
{
 int i;

 for(i=0;i<BUFFER_SIZE;i++)
 {
  pr("%d,",buffer[i]);
 }
}


void dumpdata2(void)
{
 int i;

 for(i=0;i<BUFFER_SIZE;i++)
 {
  pr("%d,%d",buffer[i],buffer2[i]);
 }
}



//*** Process serial port commands

SerialCommand sCmd;



void cmdunrecognized(const char *command)
{
 Serial.println("What?"); 
}  


void cmdgetdata(void)
{
 dumpdata();
}

void cmdgetdata2(void)
{
 dumpdata2();
}



void setup() 
{
 Serial.begin(9600);
 while (!Serial) { ; /* wait for serial port to connect. Needed for native USB */}

 sCmd.addCommand("get",cmdgetdata);  
 sCmd.addCommand("get2",cmdgetdata2);    
 sCmd.setDefaultHandler(cmdunrecognized);  


 ADCSRA =  bit (ADEN);                      // turn ADC on
 ADCSRA |= bit (ADPS1); // | bit (ADPS0); //| bit (ADPS2);  // Prescaler of 128
 ADMUX  =  bit(ADLAR) | bit (REFS0) | (ANINPUT);    // AVcc and select input port 1

 
 pinMode(OUT_PIN,OUTPUT);

//Clear ADTS2..0 in ADCSRB
 ADCSRB &=~(bit(ADTS2) | bit(ADTS1) | bit(ADTS0));
}



void loop() 
{

 TIMSK0 &= ~_BV(TOIE0); // disable timer0 overflow interrupt

 shortpause();

 bufferp=buffer;
 goping2();

 ADCSRA |= bit (ADSC) | bit(ADATE);
loop1:;

 if(ADCSRA & bit(ADIF))
 {
  if(bufferp>=bufferlt)
  {
   ADCSRA &= ~ (bit (ADSC) | bit (ADIE) | bit(ADATE));

   goto loop2;
  }
  bufferp+=2;
  *bufferp=ADCH;
  ADCSRA|= bit(ADIF);
 }
 goto loop1;
 
loop2:;  

 shortpause();

 bufferp=buffer+1;
 goping2();
 __builtin_avr_delay_cycles(26);

 ADCSRA |= bit (ADSC) | bit(ADATE);
loop1b:;

 if(ADCSRA & bit(ADIF))
 {
  if(bufferp>=bufferlt)
  {
   ADCSRA &= ~ (bit (ADSC) | bit (ADIE) | bit(ADATE));

   goto loop2b;
  }
  bufferp+=2;
  *bufferp=ADCH;
  ADCSRA|= bit(ADIF);
 }
 goto loop1b;
 
loop2b:;  

 shortpause();

 bufferp=buffer2;
 goping();

 ADCSRA |= bit (ADSC) | bit(ADATE);
loop11:;

 if(ADCSRA & bit(ADIF))
 {
  if(bufferp>=bufferlt2)
  {
   ADCSRA &= ~ (bit (ADSC) | bit (ADIE) | bit(ADATE));

   goto loop21;
  }
  bufferp+=2;
  *bufferp=ADCH;
  ADCSRA|= bit(ADIF);
 }
 goto loop11;
 
loop21:;  

 shortpause();

 bufferp=buffer2+1;
 goping();
 __builtin_avr_delay_cycles(26);

 ADCSRA |= bit (ADSC) | bit(ADATE);
loop1b1:;

 if(ADCSRA & bit(ADIF))
 {
  if(bufferp>=bufferlt2)
  {
   ADCSRA &= ~ (bit (ADSC) | bit (ADIE) | bit(ADATE));

   goto loop2b1;
  }
  bufferp+=2;
  *bufferp=ADCH;
  ADCSRA|= bit(ADIF);
 }
 goto loop1b1;
 
loop2b1:;  

 
 TIMSK0 |= _BV(TOIE0); // enable timer0 overflow interrupt
 
 if(Serial.available()>0) 
 {
  sCmd.readSerial();
 }

 delay(100);
}



